(* A simple blog as a test of transactional web services with
   nested transactions.
*)
(* The following is the continuation-based implementation, see
   test_blog_tty.ml for comparison.
*)

open Cgi
open Kcgi
open Kcgi_p
open Blog

(*
;;
#load "cgi.cmo";;
#load "kcgi.cmo";;
#load "kcgi_tty.cmo";;
#load "blog.cmo";;
*)

module MAIN(S:KCGI) = struct
  open S
  (* Where all the template files are *)
  let template_dir = "/home/oleg/caml-web";;

 let rec main () =
   let henv = inquire "blog_login.html" [] in
   let username = answer "username" henv vstring in
   let ()       = answer "password" henv 
                     (function Some s -> if s = username then Right ()
			       else Left "bad password"
		       | _ -> Left "password is missing") in
   let env = [("username",username)] in

   let edit env =			(* editing a new post *)
     let henv = inquire "blog_new.html" env in
     if answer "cancel" henv vbool then None else (* rollback *)
     let title = answer "title" henv vstring in
     let body  = answer "body" henv vstring in
     let new_post = markup username title body in
     if answer "submit" henv vbool then Some new_post (* commit *)
     else
       let () = assert (answer "preview" henv vbool) in
       let henv = inquire "blog_preview.html" (("new-post",new_post)::env) in
       if answer "submit" henv vbool then Some new_post (* commit *)
       else None

   in
   try
   in_transaction env (fun env ->	(* user session transaction *)
     let rec loop_browse () =
       let content = read_blog () in
       let henv = inquire "blog_view.html" (("blog-data",content)::env) in
       if answer "logout" henv vbool then ()
       else if not (answer "new" henv vbool) then loop_browse () else
       match			(* new post transaction *)
	 (try in_transaction env edit with TX_Gone -> None
	 | e -> failwith ("in2: " ^ Printexc.to_string e)) with
       | None -> loop_browse ()
       | Some new_post -> write_blog new_post; loop_browse ()
     in loop_browse ());
   inquire_finish "blog_logout.html" env
   with TX_Gone -> main ()
end;;

let () = 
  let module M = Run(MAIN) in M.run ()
;;
