(* A simple blog as a test of transactional web services with
   nested transactions.
*)
(* The following is the TTY implementation, for comparison
   with the continuation-based one
*)

open Cgi
open Kcgi
open Kcgi_tty
open Blog
;;
#load "cgi.cmo";;
#load "kcgi.cmo";;
#load "kcgi_tty.cmo";;
#load "blog.cmo";;


module MAIN(S:KCGI) = struct
  open S
  (* Where all the template files are *)
  let template_dir = "/home/oleg/Cache/ometa-cvs/XXCC-natdyn/delimcc";;

 let main () =
   let henv = inquire "blog_login.html" [] in
   let username = answer "username" henv vstring in
   let ()       = answer "password" henv 
                     (function Some s -> if s = username then Right ()
			       else Left "bad password"
		       | _ -> Left "password is missing") in
   let env = [("username",username)] in
   let rec loop_browse () =
     let content = read_blog () in
     let henv = inquire "blog_view.html" (("blog-data",content)::env) in
     if answer "logout" henv vbool then
       inquire_finish "blog_logout.html" env
     else
       if not (answer "new" henv vbool) then loop_browse () else
       let henv = inquire "blog_new.html" env in
       let rec loop_edit henv =
	 if answer "cancel" henv vbool then loop_browse () else
	 let title = answer "title" henv vstring in
	 let body  = answer "body" henv vstring in
	 let new_post = markup username title body in
	 if answer "submit" henv vbool then
	   let () = write_blog new_post in
	   loop_browse ()
	 else
	   let () = assert (answer "preview" henv vbool) in
	   let henv = inquire "blog_new.html"
	       ([("title",title);("body",body);("new-post",new_post)] @ env) in
	   loop_edit henv
       in loop_edit henv
   in loop_browse ()
       
end;;

let () = 
  let module M = Run(MAIN) in M.run ()
;;
